import { Column, DefaultPlatform, IndexModel, SqlPlaceholderStrategy, Table } from '@deepkit/sql';
import { ReflectionClass, ReflectionProperty, Serializer } from '@deepkit/type';
import { PostgresSchemaParser } from './postgres-schema-parser';
import { PostgreSQLFilterBuilder } from './sql-filter-builder';
export declare class PostgresPlaceholderStrategy extends SqlPlaceholderStrategy {
    getPlaceholder(): string;
}
export declare class PostgresPlatform extends DefaultPlatform {
    protected defaultSqlType: string;
    protected annotationId: string;
    readonly serializer: Serializer;
    schemaParserType: typeof PostgresSchemaParser;
    placeholderStrategy: typeof PostgresPlaceholderStrategy;
    constructor();
    getAggregateSelect(tableName: string, property: ReflectionProperty, func: string): string;
    createSqlFilterBuilder(schema: ReflectionClass<any>, tableName: string): PostgreSQLFilterBuilder;
    quoteValue(value: any): string;
    getColumnDDL(column: Column): string;
    getUniqueDDL(unique: IndexModel): string;
    getDropIndexDDL(index: IndexModel): string;
    supportsInlineForeignKey(): boolean;
    getAutoIncrement(): string;
    getDropTableDDL(table: Table): string;
    getUseSchemaDDL(table: Table): string;
    getResetSchemaDDL(table: Table): string;
}
